YUI.add('netgen-tags-app-plugin', function (Y) {
    "use strict";

    Y.namespace('Netgen.Tags.Plugin');

    Y.Netgen.Tags.Plugin.AppPlugin = Y.Base.create('NetgenTagsAppPlugin', Y.Plugin.Base, [], {
        initializer: function () {
            var app = this.get('host');

            app.views.NetgenTagsServerSideView = {
                type: Y.Netgen.Tags.View.ServerSideView
            };

            Y.Netgen.Tags.View.ServerSideView.app = app;

            this.addRoutes(app);
        },

        addRoutes: function (app) {
            app.route({
                name: "NetgenTagsSearch",
                regex: /\/tags\/(tags%2Fadmin%2Fsearch%2F.*)/,
                keys: ['uri'],
                path: "/tags/:uri",
                sideViews: {'navigationHub': true, 'discoveryBar': false},
                service: Y.Netgen.Tags.Service.ServerSideViewService,
                view: "NetgenTagsServerSideView",
                callbacks: ['open', 'checkUser', 'handleSideViews', 'handleMainView']
            });

            app.route({
                name: "NetgenTagsSearchWithSearchText",
                regex: /\/tags\/(tags%2Fadmin%2Fsearch%2F%3FsearchText%3D.*)/,
                keys: ['uri'],
                path: "/tags/tags%2Fadmin%2Fsearch%2F%3FsearchText%3D:searchText",
                sideViews: {'navigationHub': true, 'discoveryBar': false},
                service: Y.Netgen.Tags.Service.ServerSideViewService,
                view: "NetgenTagsServerSideView",
                callbacks: ['open', 'checkUser', 'handleSideViews', 'handleMainView']
            });

            app.route({
                name: "NetgenTagsDashboard",
                regex: /\/tags\/(tags%2Fadmin%2F.*)/,
                keys: ['uri'],
                path: "/tags/:uri",
                sideViews: {'navigationHub': true, 'discoveryBar': false},
                service: Y.Netgen.Tags.Service.ServerSideViewService,
                view: "NetgenTagsServerSideView",
                callbacks: ['open', 'checkUser', 'handleSideViews', 'handleMainView']
            });

            app.route({
                name: "NetgenTagsGenericRoute",
                path: "/tags/:uri",
                sideViews: {'navigationHub': true, 'discoveryBar': false},
                service: Y.Netgen.Tags.Service.ServerSideViewService,
                view: "NetgenTagsServerSideView",
                callbacks: ['open', 'checkUser', 'handleSideViews', 'handleMainView']
            });
        },
    }, {
        NS: 'NetgenTagsApp'
    });

    Y.eZ.PluginRegistry.registerPlugin(
        Y.Netgen.Tags.Plugin.AppPlugin, ['platformuiApp']
    );
});
